package gui;

import java.awt.Color;
import java.awt.EventQueue;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.SwingConstants;
import javax.swing.border.EmptyBorder;

import aplicacao.Calculadora;

import javax.swing.JToggleButton;
import javax.swing.JCheckBox;

import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;

import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public class JanelaCalculadora extends JFrame {

	private JPanel contentPane;
	private JTextField txtMdc;
	private JTextField txtY;
	private JTextField txtX;
	private final ButtonGroup buttonGroup = new ButtonGroup();
	private JRadioButton rdbtnNi;
	private JRadioButton rdbtnI;
	private JRadioButton rdbtnN;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					JanelaCalculadora frame = new JanelaCalculadora();
					frame.setVisible(true);
				}
				catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public JanelaCalculadora() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 350, 190);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		
		JLabel lblCalculadora = new JLabel("Calculadora");
		lblCalculadora.setHorizontalAlignment(SwingConstants.CENTER);
		
		JLabel lblX = new JLabel("x = ");
		lblX.setHorizontalAlignment(SwingConstants.TRAILING);
		
		JLabel lblY = new JLabel("y = ");
		lblY.setHorizontalAlignment(SwingConstants.TRAILING);
		
		JLabel lblMdc = new JLabel("mdc(x, y) = ");
		lblMdc.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				JanelaCalculadora.this.getContentPane().setBackground(Color.BLUE);
			}
		});
		lblMdc.setHorizontalAlignment(SwingConstants.TRAILING);
		
		txtMdc = new JTextField();
		txtMdc.setEditable(false);
		txtMdc.setColumns(10);
		
		txtY = new JTextField();
		txtY.setColumns(10);
		
		txtX = new JTextField();
		txtX.setColumns(10);
		
		JButton btnCalcular = new JButton("Calcular");
		btnCalcular.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Calculadora calc = new Calculadora();
				int x = Integer.parseInt(txtX.getText());
				int y = Integer.parseInt(txtY.getText());
				txtMdc.setText("" + calc.mdc(x, y));
			}
		});
		
		rdbtnN = new JRadioButton("N");
		rdbtnN.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				tratarMudancaFonte();
			}
		});
		buttonGroup.add(rdbtnN);
		
		rdbtnI = new JRadioButton("I");
		rdbtnI.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				tratarMudancaFonte();
			}
		});
		buttonGroup.add(rdbtnI);
		
		rdbtnNi = new JRadioButton("N+I");
		rdbtnNi.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				tratarMudancaFonte();
			}
		});
		buttonGroup.add(rdbtnNi);
		GroupLayout gl_contentPane = new GroupLayout(contentPane);
		gl_contentPane.setHorizontalGroup(
			gl_contentPane.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_contentPane.createSequentialGroup()
					.addContainerGap()
					.addGroup(gl_contentPane.createParallelGroup(Alignment.TRAILING)
						.addComponent(lblCalculadora, GroupLayout.DEFAULT_SIZE, 328, Short.MAX_VALUE)
						.addGroup(gl_contentPane.createSequentialGroup()
							.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING, false)
								.addComponent(lblMdc, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
								.addComponent(lblX, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
								.addComponent(lblY, GroupLayout.DEFAULT_SIZE, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
							.addPreferredGap(ComponentPlacement.RELATED)
							.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
								.addComponent(txtY, GroupLayout.DEFAULT_SIZE, 246, Short.MAX_VALUE)
								.addComponent(txtMdc, GroupLayout.DEFAULT_SIZE, 246, Short.MAX_VALUE)
								.addComponent(txtX, GroupLayout.DEFAULT_SIZE, 246, Short.MAX_VALUE)))
						.addGroup(gl_contentPane.createSequentialGroup()
							.addComponent(rdbtnNi)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(rdbtnI)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(rdbtnN)
							.addPreferredGap(ComponentPlacement.RELATED)
							.addComponent(btnCalcular)))
					.addContainerGap())
		);
		gl_contentPane.setVerticalGroup(
			gl_contentPane.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_contentPane.createSequentialGroup()
					.addComponent(lblCalculadora)
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
						.addComponent(lblX)
						.addComponent(txtX, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
						.addComponent(lblY)
						.addComponent(txtY, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.RELATED)
					.addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
						.addComponent(lblMdc)
						.addComponent(txtMdc, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
					.addPreferredGap(ComponentPlacement.RELATED, GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
					.addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
						.addComponent(btnCalcular)
						.addComponent(rdbtnN)
						.addComponent(rdbtnI)
						.addComponent(rdbtnNi))
					.addContainerGap())
		);
		contentPane.setLayout(gl_contentPane);
	}
	
	private void tratarMudancaFonte() {
		if (rdbtnI.isSelected()) {
			Font f = txtMdc.getFont().deriveFont(Font.ITALIC);
			txtMdc.setFont(f);
		}
		else if (rdbtnN.isSelected())	{
			Font f = txtMdc.getFont().deriveFont(Font.BOLD);
			txtMdc.setFont(f);			
		}
		else if (rdbtnNi.isSelected()) {
			Font f = txtMdc.getFont().deriveFont(Font.BOLD + Font.ITALIC);
			txtMdc.setFont(f);						
		}
	}
}
