package gui;

import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.HashSet;
import java.util.Set;

import javax.swing.JFrame;
import javax.swing.JPanel;

public class JanelaDesenho extends JFrame {
	public JanelaDesenho() {
		super("Janela de desenho");
		setBounds(50, 50, 500, 500);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		init();
	}
	
	private void init() {
		final PainelDesenho painel = new PainelDesenho();
		setContentPane(painel);
		
		painel.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				painel.pontos.add(e.getPoint());
				JanelaDesenho.this.repaint();
			}
		});
	}
		
	public static void main(String[] args) {
		JanelaDesenho janela = new JanelaDesenho();
		janela.setVisible(true);
	}

	private class PainelDesenho extends JPanel {
		Set<Point> pontos = new HashSet<>();
		
		@Override
		protected void paintComponent(Graphics g) {
			super.paintComponent(g);
			for (Point p : pontos) g.fillOval(p.x, p.y, 5, 5);
		}
	}
}

