package gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;

public class JanelaMouse extends JFrame {
	private JLabel rotuloCentro;
	private JLabel rotuloRodape;
	
	public JanelaMouse() {
		super("Eventos de Mouse");
		setBounds(50, 50, 300, 300);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		init();
	}
	
	private void init() {
		rotuloCentro = new JLabel();
		rotuloCentro.setOpaque(true);
		add(rotuloCentro, BorderLayout.CENTER);
		
		rotuloRodape = new JLabel();
		add(rotuloRodape, BorderLayout.PAGE_END);
		rotuloRodape.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				JOptionPane.showMessageDialog(JanelaMouse.this, "Você clicou no rodapé!");
			}
		});
		
		MonitorMouse mm = new MonitorMouse();
		rotuloCentro.addMouseListener(mm);
		rotuloCentro.addMouseMotionListener(mm);
	}

	public static void main(String[] args) {
		JanelaMouse janela = new JanelaMouse();
		janela.setVisible(true);
	}
	
	private class MonitorMouse implements MouseListener, MouseMotionListener {
		@Override
		public void mouseDragged(MouseEvent e) {
			rotuloRodape.setText("Arrastando: (" + e.getX() + ", " + e.getY() + ")");
		}

		@Override
		public void mouseMoved(MouseEvent e) {
			rotuloRodape.setText("Movimento: (" + e.getX() + ", " + e.getY() + ")");
		}

		@Override
		public void mouseClicked(MouseEvent e) {
			rotuloRodape.setText("Clique: (" + e.getX() + ", " + e.getY() + ")");
		}

		@Override
		public void mousePressed(MouseEvent e) {
			rotuloRodape.setText("Pressionado: (" + e.getX() + ", " + e.getY() + ")");
		}

		@Override
		public void mouseReleased(MouseEvent e) {
			rotuloRodape.setText("Liberado: (" + e.getX() + ", " + e.getY() + ")");
		}

		@Override
		public void mouseEntered(MouseEvent e) {
			rotuloCentro.setBackground(Color.GREEN);
		}

		@Override
		public void mouseExited(MouseEvent e) {
			rotuloCentro.setBackground(Color.RED);
		}
	}
}
